Skip to navigation

Apply a credit memo

View as Markdown

Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

Applies a posted credit memo to one or more invoices and debit memos.

You can apply a credit memo to an invoice or a debit memo only if you have the user permission. See Billing Roles for more information.

When you apply a credit memo, the total number of credit memo items and the items that credit memo items to be applied to must be less than or equal to 15,000.

If the limit is hit, you can follow the following instructions:

  • If you want to apply one credit memo to multiple invoices or debit memos, decrease the number of invoices or debit memos in the request.
  • If you want to apply one credit memo to a single invoice or debit memo with a large volume of items, you have to specify invoice items or debit memo items in the request. The maximum number of invoice items or debit memo items that you can specify in the request is 1,000.
  • If a credit memo has a large volume of items, you have to specify credit memo items in the request. The maximum number of credit memo items that you can specify in the request is 1,000.

If the Proration application rule is used, when applying credit memos, the following quantity must be less than or equal to 10,000:

(number of invoice items + number of debit memo items) * number of credit memo items

Otherwise, the First In First Out rule will be used instead of the Proration rule.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

creditMemoKeystringRequired
The unique ID or number of a credit memo. For example, 8a8082e65b27f6c3015ba45ff82c7172.

Headers

Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Request

This endpoint expects an object.
applicationRuleenumOptional

The application rule to use when applying the credit memo. If you do not specify this field, the tenant-level application rule will be used.

Restrictions:

  • This rule can only be applied to a single invoice, and cannot be applied to debit memos.
  • This rule cannot be used together with the items field.
Allowed values:
debitMemoslist of objectsOptional
Container for debit memos that the credit memo is applied to. The maximum number of debit memos is 1,000.
effectiveDatedateOptional
The date when the credit memo is applied.
invoiceslist of objectsOptional
Container for invoices that the credit memo is applied to. The maximum number of invoices is 1,000.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
accountIdstringOptional
The ID of the customer account associated with the credit memo.
accountNumberstringOptional
The number of the customer account associated with the credit memo.
amountdoubleOptional
The total amount of the credit memo.
appliedAmountdoubleOptional
The applied amount of the credit memo.
autoApplyUponPostingbooleanOptional
Whether the credit memo automatically applies to the invoice upon posting.
billToContactIdstring or nullOptional

The ID of the bill-to contact associated with the credit memo.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

billToContactSnapshotIdstring or nullOptional

The ID of the bill-to contact snapshot associated with the credit memo.

The value of this field is null if the bill rule Preserve snapshot of bill-to and sold-to contacts when billing documents are posted is disabled.

cancelledByIdstring or nullOptional
The ID of the Zuora user who cancelled the credit memo.
cancelledOnstring or nullOptional

The date and time when the credit memo was cancelled, in yyyy-mm-dd hh:mm:ss format.

commentstring or nullOptional
Comments about the credit memo.
createdByIdstringOptional
The ID of the Zuora user who created the credit memo.
createdDatestringOptional

The date and time when the credit memo was created, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-01 15:31:10.

creditMemoDatedateOptional

The date when the credit memo takes effect, in yyyy-mm-dd format. For example, 2017-05-20.

currencystring or nullOptional

The currency of the credit memo.

Note: By default, the currency on a billing document matches the default currency set on the associated account. However, Zuora now offers a Multiple Currencies feature to support different currencies for billing documents, allowing flexibility beyond the account-level currency. For more information, see Multiple Currency.

einvoiceErrorCodestring or nullOptional

The error code returned when the e-invoice file status is Failed. This code can either be a Zuora-generated error code or one returned by a third-party e-invoicing service provider.

Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

einvoiceErrorMessagestring or nullOptional

The error message returned when the e-invoice file status is Failed. This message can either be a Zuora-generated error message or one returned by a third-party e-invoicing service provider.

Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

einvoiceFileIdstring or nullOptional

The ID of the e-invoice file generated for the credit memo.

Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

einvoiceStatusenum or nullOptional

The status of the e-invoice file generation for the credit memo.

  • If e-invoice file generation succeeds, this field is either Generated or Success, and both the error code and message are empty, and the eInvoiceFileId field stores the ID of the generated e-invoice file.

  • If the responses from tax vendors such as Sovos or Avalara are taking too long, this field becomes RetrieveTimeOut. Once the vendor responds successfully, you can use the ‘Resync E-Invoice Status’ action to update the status automatically. You can view these updates in System Health telemetry.

  • If a failure occurs during e-invoice file generation, this field is Failed and an error code and an error message are returned respectively in the einvoiceErrorCode and einvoiceErrorMessage fields.

  • If e-invoice file generation conditionally succeeds, this field is ConditionalSuccess and an error code and an error message are returned respectively in the einvoiceErrorCode and einvoiceErrorMessage fields.

  • If the e-invoice file has been approved by the tax authority, this field is ApprovedByAuthority. The next status will be either Success or Rejected.

  • If the e-invoice file has been rejected by the government, this field is Rejected. You cannot resend this e-invoice; you must create a new invoice instead.

    Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.

excludeFromAutoApplyRulesbooleanOptional
Whether the credit memo is excluded from the rule of automatically applying credit memos to invoices.
excludeItemBillingFromRevenueAccountingbooleanOptional

The flag to exclude the credit memo item from revenue accounting.

Note: This field is only available if you have the Billing - Revenue Integration feature enabled.

idstringOptional
The unique ID of the credit memo.
invoiceGroupNumberstring or nullOptional

The number of the invoice group associated with the credit memo.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

latestPDFFileIdstring or nullOptional
The ID of the latest PDF file generated for the credit memo.
numberstringOptional
The unique identification number of the credit memo.
organizationLabelstringOptional

The organization that this object belongs to.

Note: This field is available only when the Multi-Org feature is enabled.

postedByIdstring or nullOptional
The ID of the Zuora user who posted the credit memo.
postedOnstring or nullOptional

The date and time when the credit memo was posted, in yyyy-mm-dd hh:mm:ss format.

reasonCodestringOptional
A code identifying the reason for the transaction. The value must be an existing reason code or empty.
referredInvoiceIdstring or nullOptional
The ID of a referred invoice.
refundAmountdoubleOptional
The amount of the refund on the credit memo.
revenueImpactingenumOptionalDefaults to Yes

Indicates whether this write off operation impacts the revenue. If revenueImpacting = Yes, the deferred revenue accounting code will be automatically selected from the associated invoice

If revenueImpacting = No, users can select an accounting code such as bad-debt expense accounting code for the write off operation.

Allowed values:
reversedbooleanOptional
Whether the credit memo is reversed.
sequenceSetIdstring or nullOptional

The ID of the sequence set associated with the credit memo.

The value of this field is null if you have the Flexible Billing Attributes feature disabled.

communicationProfileIdstring or nullOptional

The ID of the communication profile associated with the credit memo.

Note: This field is available in the request body only if you have the Flexible Billing Attributes feature turned on. The value is null in the response body without this feature turned on.

sourcestringOptional

The source of the credit memo.

Possible values:

  • BillRun: The credit memo is generated by a bill run.
  • API: The credit memo is created by calling the Invoice and collect operation, or by calling the Orders, Order Line Items, or Fulfillments API operations.
  • ApiSubscribe: The credit memo is created by calling the Create subscription and Create account operation.
  • ApiAmend: The credit memo is created by calling the Update subscription operation.
  • AdhocFromPrpc: The credit memo is created from a product rate plan charge through the Zuora UI or by calling the Create a credit memo from a charge operation.
  • AdhocFromInvoice: The credit memo is created from an invoice or created by reversing an invoice. You can create a credit memo from an invoice through the Zuora UI or by calling the Create credit memo from invoice operation. You can create a credit memo by reversing an invoice through the Zuora UI or by calling the Reverse invoice operation.
sourceIdstring or nullOptional

The ID of the credit memo source.

If a credit memo is generated from a bill run, the value is the number of the corresponding bill run. Otherwise, the value is null.

sourceTypeenumOptional
The type of the credit memo source.
statusenumOptional
The status of the credit memo.
successbooleanOptional

Returns true if the request was processed successfully.

targetDatedate or nullOptional

The target date for the credit memo, in yyyy-mm-dd format. For example, 2017-07-20.

taxAmountdoubleOptional
The amount of taxation.
taxMessagestring or nullOptional
The message about the status of tax calculation related to the credit memo. If tax calculation fails in one credit memo, this field displays the reason for the failure.
taxStatusenum or nullOptional

The status of tax calculation related to the credit memo.

Note: This field is only applicable to tax calculation by third-party tax engines. Also, the Voided status indicates that the tax transaction is successfully canceled on the tax vendor’s side. If a tax transaction was successfully committed to the third-party tax engine but the invoice failed to post, Zuora automatically detects the issue and voids the tax transaction on the vendor’s side.

totalTaxExemptAmountdoubleOptional
The calculated tax amount excluded due to the exemption.
transferredToAccountingenumOptional
Whether the credit memo was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite.
Allowed values:
unappliedAmountdoubleOptional
The unapplied amount of the credit memo.
updatedByIdstringOptional
The ID of the Zuora user who last updated the credit memo.
updatedDatestringOptional

The date and time when the credit memo was last updated, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-01 15:36:10.

IntegrationId__NSstringOptional<=255 characters

ID of the corresponding object in NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

IntegrationStatus__NSstringOptional<=255 characters

Status of the credit memo’s synchronization with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

Origin__NSstringOptional<=255 characters

Origin of the corresponding object in NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

SyncDate__NSstringOptional<=255 characters

Date when the credit memo was synchronized with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

Transaction__NSstringOptional<=255 characters

Related transaction in NetSuite. Only available if you have installed the Zuora Connector for NetSuite.

Errors

4XX
Client Request Error
500
Internal Server Error